#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <string.h>
#include <bios.h>
#include <math.h>
#include "/tony/include/def.h"
#include "/tony/include/commio.h"

#define XCENTER getmaxx() / 2
#define YCENTER getmaxy() / 2

struct points {
   int chan[4];
   float xpos[4];
   float ypos[4];
   float zpos[4];
} coor;

void	drawpos(struct points coor);
struct  points getpos(void);
/**************************************************************************
 *                                  Main                                  *
 **************************************************************************/
void
main(void) {
    int i;
    int gdriver = DETECT, gmode, errorcode;
    int qresp = 0;

    if (CommOpen(COM1)) {
       printf("Error initializing port.\n");
       exit(0);
    }
    if (CommSetSpeed(COM1,57600)) {
       printf("Error initializing speed.\n");
       exit(0);
    }
    if (registerbgidriver(EGAVGA_driver) < 0) {
       printf("Unable to register BGI driver\n");
       exit(0);
    }
    initgraph(&gdriver, &gmode,"");
    errorcode = graphresult();
    if (errorcode != grOk) {
       printf("Graphics error: %s\n", grapherrormsg(errorcode));
       exit(0);
    }

    setcolor(LIGHTGRAY);
    setfillstyle(SOLID_FILL,LIGHTGRAY);
    bar(0,460,640,480);
    setcolor(RED);
    outtextxy(20,466,"ESC");
    setcolor(BLACK);
    outtextxy(50,466,"to exit");
    setcolor(WHITE);
    while (qresp != 0x1b) {
       coor = getpos();
       drawpos(coor);
       while(kbhit())
	  qresp = getch();
    }
    closegraph();
    CommClearTX(COM1);
    CommClearRX(COM1);
    CommClose(COM1);
}

/**************************************************************************
 *                           Gets Marker Positions                        *
 **************************************************************************/
struct points
getpos (void) {
    char rxint[1024];
    char tmpbuf[32];
    char tmpchar;
    int bufsize;
    int bufnow = 1;
    int complete = 0;
    int i;

    CommClearTX(COM1);
    CommClearRX(COM1);
    CommTXChar(COM1,'P');
    delay(100);
    bufsize = CommRXCount(COM1);
    if (bufsize > 0 && bufsize < 1024) {
       for (i = 0; i < bufsize; i++) {
	  rxint[i] = CommRXChar(COM1);
       }
       rxint[bufsize-2] = '\r';
       rxint[bufsize-1] = '\n';
       rxint[bufsize] = '\0';
    }

    while ((bufnow < bufsize) && (complete <= 16)) {
       tmpchar = i = 0;
       while(tmpchar != ' ' && tmpchar != '\r') {
	  tmpchar = rxint[bufnow];     // read current char
	  tmpbuf[i] = tmpchar;         // append to temp buffer
	  bufnow += 1;
	  i += 1;
	  if (tmpchar == '-' && i != 1) {
	     tmpchar = ' ';            // exit this while loop
	     bufnow -= 1;              // back up buf ptr 1 pos
	  }
       }
       tmpbuf[i-1] = '\0';            // remove ' ' or '\r' or '-'
       while(tmpchar == ' ') {
	  tmpchar = rxint[bufnow];
	  bufnow += 1;
       }
       bufnow -= 1;   // back up buf ptr 1 pos since valid char just been read
       if (complete % 4 == 0)
	  coor.chan[complete/4] = atoi(tmpbuf);
       else if (complete % 4 == 1)
	  coor.xpos[complete/4] = atof(tmpbuf);
       else if (complete % 4 == 2)
	  coor.ypos[complete/4] = atof(tmpbuf);
       else {
	  coor.zpos[complete/4] = atof(tmpbuf);
	  while(tmpchar != '\r') {
	     tmpchar = rxint[bufnow];     // read char until '\r'
	     bufnow += 1;
	  }
	  bufnow += 1;                   // move pointer past '\n' after '\r'
       }
       complete += 1;
    }
    return(coor);
}
/**************************************************************************
 *                        Plots Marker Position(s)                        *
 **************************************************************************/
void
drawpos(struct points coor) {
    char tmpchar[12];
    int dp;
    int i;
    int xnew,ynew;

    setfillstyle(SOLID_FILL,BLACK);
    bar(255,20,380,120);
    setcolor(WHITE);
    line(320,100,320,400);
    line(320,300,520,300);
    line(200,420,320,300);

//    line(320,270,520,270);
//    line(200,390,320,270);
    for (i = 0; i < 4; i++) {
       if (!i) {
	  setcolor(RED);
	  setfillstyle(SOLID_FILL,RED);
       }
       else if (i == 1) {
	  setcolor(GREEN);
	  setfillstyle(SOLID_FILL,GREEN);
       }
       else if (i == 2) {
	  setcolor(BLUE);
	  setfillstyle(SOLID_FILL,BLUE);
       }
       else {
	  setcolor(YELLOW);
	  setfillstyle(SOLID_FILL,YELLOW);
       }
       xnew = 320 + 2*((int)coor.xpos[i] - (int)sqrt(abs(coor.zpos[i])));
       ynew = 300 - 2*((int)coor.ypos[i] - (int)sqrt(abs(coor.zpos[i])));
// need to add if z is negative
       fillellipse(xnew,ynew,2,2);
       outtextxy(265,20+i*20,itoa(coor.chan[i],tmpchar,10));
       outtextxy(295,20+i*20,itoa(coor.xpos[i],tmpchar,10));
       outtextxy(325,20+i*20,itoa(coor.ypos[i],tmpchar,10));
       outtextxy(355,20+i*20,itoa(coor.zpos[i],tmpchar,10));
    }
}
