unit reg;

interface
{$DEFINE NOTuseSynaSer}
//{$DEFINE useSynaSer}

uses
{$IFDEF useSynaSer}
  SynaSer,
{$ELSE}
   ComPort,
{$ENDIF}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Buttons, e_memmap,ToolWin, ComCtrls, ExtCtrls, Menus, StdCtrls,
  Spin,regmult,FOB, registry;

type
  TRegForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Position1: TMenuItem;
    ResampleMRI1: TMenuItem;
    Timer1: TTimer;
    ToolBar2: TToolBar;
    RegGrid: TStringGrid;
    Label2: TLabel;
    XEdit: TSpinEdit;
    YEdit: TSpinEdit;
    ZEdit: TSpinEdit;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    desirex: TSpinEdit;
    desirey: TSpinEdit;
    desirez: TSpinEdit;
    Label3: TLabel;
    DistanceLabel: TLabel;
    FormulaLabel: TLabel;
    FOB1: TMenuItem;
    N96001: TMenuItem;
    N192001: TMenuItem;
    N384001: TMenuItem;
    N576001: TMenuItem;
    N1152001: TMenuItem;
    Label4: TLabel;
    CoolBar1: TCoolBar;
    OPenBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    AddBtn: TSpeedButton;
    DeleteBtn: TSpeedButton;
    SpeedButton1: TSpeedButton;
    AddMRI1: TMenuItem;
    AddRowMRIFOB1: TMenuItem;
    dxFOBlabel: TLabel;
    QueryOrSampleBtn: TSpeedButton;
    Mode1: TMenuItem;
    CalibrateItem: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    FlockofBirdsMiniBird1: TMenuItem;
    Fast1: TMenuItem;
    Connection1: TMenuItem;
    Type1: TMenuItem;
    ResampleFOB1: TMenuItem;
    AdvancedMenuItem: TMenuItem;
    ResetConnectionMenu: TMenuItem;
    PortMenu: TMenuItem;
    FlockofBirdsMiniBirdStream1: TMenuItem;
    procedure FormCreate(Sender: TObject);
procedure SetShareMem (lX,lY,lZ: integer);
    procedure SetFOBcell(lRow,lX,lY,lZ:integer);
    procedure SetMRIcell(lRow,lX,lY,lZ:integer);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure XEditChange(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure ResampleMRI1Click(Sender: TObject);
    procedure RegGridChangeRow(Row: integer);
    procedure RegGridDblClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure OPenBtnClick(Sender: TObject);
    procedure RegBtnClick(Sender: TObject);
    procedure ToolbarVis;
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure TableBtnClick(Sender: TObject);
    procedure N1152001Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure AddMRI1Click(Sender: TObject);
    procedure AddRowMRIFOB1Click(Sender: TObject);
    procedure QueryOrSampleBtnClick(Sender: TObject);
    procedure StartupFOB(Sender: TObject);
    procedure ModeClick(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Fast1Click(Sender: TObject);
    procedure RegGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RegGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure RegGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ResetConnectionMenuClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure updateModeMenu;
    //function ComIn: Integer;
  function ReadFastrak: boolean;
  procedure InitFOB;
  procedure InitFOBdialog;

function ReadFOB: boolean;{only 8 msb}

  private
  EMemMap : TEMemMap;
      { Private declarations }
  public
    { Public declarations }
  end;


Const
      kShareRASz = 32;

var
  RegForm: TRegForm;
  g1st,gAbortRefresh: boolean;
  gXProj,gYProj,gZProj: integer;
type

     IntArr = Array[1..kShareRASz] Of Integer;
     IntArrPtr = ^IntArr;

implementation

{$R *.DFM}
var
 gXFOB,gYFOB,gZFOB: integer;
 gNewLine: boolean = false;
 gCurrentFastrackFragment : string = '';
 gFOBactive: boolean = false;
 gPort : string = '';
 gBPS : integer = 115200;
 gIsFastrak : boolean = true;
 gIsStreaming : boolean = true; //set flock of birds to streaming mode instead of point mode
 {$IFDEF useSynaSer}
 Serial1:TBlockSerial;
{$ELSE}
  Serial1 : TComPort;
{$ENDIF}


procedure TRegForm.SetFOBcell(lRow,lX,ly,lZ: integer);
begin
            RegGrid.Cells[1,lRow] := inttostr(lX)+':'+inttostr(lY)+':'+inttostr(lZ);
           gMRIFOBra[lRow].fobx := lX;
           gMRIFOBra[lRow].foby := lY;
           gMRIFOBra[lRow].fobz := lZ;
end;

procedure TRegForm.SetMRIcell(lRow,lX,ly,lZ: integer);
begin
     RegGrid.Cells[0,lRow] := inttostr(lX)+':'+inttostr(lY)+':'+inttostr(lZ);
     gMRIFOBra[lRow].mrix := lX;
     gMRIFOBra[lRow].mriy := lY;
     gMRIFOBra[lRow].mriz := lZ;
end;

procedure TRegForm.SetShareMem (lX,lY,lZ: integer);
Var
    lXmm,lYmm,lZmm : integer;
  begin
    EMemMap.EnterCriticalSection;
    Try
      IntArrPtr(EMemMap.MemMap)^[1]:=(lX);
      IntArrPtr(EMemMap.MemMap)^[2]:=(lY);
      IntArrPtr(EMemMap.MemMap)^[3]:=(lZ);
      lXmm := MaxInt;
      lYmm := 0;
      lZmm := 0;
      IntArrPtr(EMemMap.MemMap)^[4]:=Round(lXmm);
      IntArrPtr(EMemMap.MemMap)^[5]:=Round(lYmm);
      IntArrPtr(EMemMap.MemMap)^[6]:=Round(lZmm);
    Finally
      EMemMap.LeaveCriticalSection;
    end;
end;


procedure TRegForm.FormCreate(Sender: TObject);
var    IArr    : IntArrPtr;
//lRA: array [1..4] of integer;
 I: integer;
begin

  DecimalSeparator := '.';
  OpenDialog1.InitialDir := extractfilepath(paramstr(0));
  SaveDialog1.InitialDir := extractfilepath(paramstr(0));
    EMemMap:=TEMemMap.Create(Self);
  EMemMap.CreateMutex('MRICROMUTEX1');
  If NOT EMemMap.MapExisting('MRICROMAP1',SizeOf(IntArr)) then begin
    g1st := true;
    New(IArr);
    For I:=1 To kShareRASz do
      IArr^[I]:=0;
    Try
      If NOT EMemMap.CreateMemMap('MRICROMAP1',SizeOf(IntArr),IArr^) then
        EMemMap.RaiseMappingException;
    Finally
      Dispose(IArr);
    end;
     SetShareMem (1,1,1)
  end else g1st := false;
   // Serial1:=TBlockSerial.Create;

  (*RegGrid.Cells[0,0] := 'MRI';
  RegGrid.Cells[1,0] := 'Flock of Birds';
  if gIsFastrak then Fast1.checked := true; *)
end;

procedure WriteReg;
var
 RegNGFS: TRegistry;
begin
   RegNGFS:= TRegistry.Create;
   try
     RegNGFS.RootKey := HKEY_CURRENT_USER;
     if RegNGFS.OpenKey('SOFTWARE\MRIreg', TRUE) then begin
       RegNGFS.WriteString('PortName', gPort);
       RegNGFS.WriteInteger('BPS', gBPS);
       RegNGFS.WriteBool('IsFastrak',gIsFastrak);
       RegNGFS.WriteBool('IsStreaming',gIsStreaming);
     end;
   finally
     RegNGFS.Free;
   end;
end;

procedure TRegForm.FormDestroy(Sender: TObject);
begin
  EMemMap.Free;
  WriteReg;
  if Serial1.InstanceActive then   begin
    Serial1.SendByte(ord('B')); //point command stops any streaming
    Serial1.SendByte(ord('G'));//sleep
  end;
  Serial1.CloseSocket;
  Serial1.free;
end;

procedure TRegForm.Timer1Timer(Sender: TObject);
//Communicate with MRIcro using Windows shared memory
var
   lXProj,lYProj,lZProj: integer;
   //lAbort : boolean;
   lDX : double;
begin
  if Timer1.Tag > 0 then begin
    Timer1.Tag := 0;
    Timer1.Enabled := false;
    StartupFOB (Sender);
    exit;
  end;
  if RegGrid.Visible then begin
    EMemMap.EnterCriticalSection;
    Try
      lXProj:=IntArrPtr(EMemMap.MemMap)^[1];
      lYProj:=IntArrPtr(EMemMap.MemMap)^[2];
      lZProj:=IntArrPtr(EMemMap.MemMap)^[3];
    Finally
      EMemMap.LeaveCriticalSection;
    end;
    if (lXProj <> gXProj) or (lYProj <> gYProj) or (lZProj <> gZProj) then begin
       gXProj := lxProj;
       gYProj := lYProj;
       gZProj := lZProj;
       gAbortRefresh := true;
       XEdit.value := gXProj;
       YEdit.Value := gYProj;
       ZEdit.value := gZProj;
       gAbortRefresh := false;
    end;
  end;
  if (ReadFOB) then begin
       gAbortRefresh := true;
       //XFOBlabel.caption := inttostr(gXFOB);
       //YFOBlabel.caption := inttostr(gYFOB);
       //ZFOBlabel.caption := inttostr(gZFOB);
       lDx :=sqrt(sqr(gXFOB/1000)+sqr(gYFOB/1000)+sqr(gZFOB/1000))  ;
       //dxFOBlabel.caption := Format(' x%6d y%6d z%6d d%6d', [gXFOB, gYFOB, gZFOB, round(lDX)]);
       if lDx > 30 then
        dxFOBlabel.Font.Color := clRed
       else
        dxFOBlabel.Font.Color := clBlack;

       dxFOBlabel.caption := Format(' x%7.1f y%7.1f z%7.1f d%7.1f', [gXFOB/1000, gYFOB/1000, gZFOB/1000, lDX]);
       if not RegGrid.Visible then begin
           gXProj := round(gCoregRA[1,0]+
           (gCoregRA[1,1]*gXFOB) + (gCoregRA[1,2]*gYFOB) +(gCoregRA[1,3]*gZFOB));
           gYProj := round(gCoregRA[2,0]+
           (gCoregRA[2,1]*gXFOB) + (gCoregRA[2,2]*gYFOB) +(gCoregRA[2,3]*gZFOB));
           gZProj := round(gCoregRA[3,0]+
           (gCoregRA[3,1]*gXFOB) + (gCoregRA[3,2]*gYFOB) +(gCoregRA[3,3]*gZFOB));
           XEdit.value := gXProj;
           YEdit.Value := gYProj;
           ZEdit.value := gZProj;
           SetShareMem (gXProj,gYProj,gZProj);
           lDX := sqrt(sqr(gXProj-DesireX.value)+sqr(gYProj-DesireY.value)+
           sqr(gXProj-DesireX.value));
           DistanceLabel.Caption := floattostrf(lDX,ffFixed,4,1);
       end;
       gAbortRefresh := false;
    end;
end;

procedure TRegForm.XEditChange(Sender: TObject);
begin
  if not gAbortRefresh then begin
        gXProj := XEdit.value;
        gYProj := YEdit.value;
        gZProj := ZEdit.value;
        SetShareMem (gXProj,gYProj,gZProj);
  end;
end;

procedure TRegForm.DeleteBtnClick(Sender: TObject);
  var
  lGrid: TGridRect;
  lInc,lY :integer;
begin
  if RegGrid.RowCount < 3 then exit;
  lGrid := RegGrid.Selection;
  lY := lGrid.top;
  if (lY+1) < (RegGrid.RowCount) then begin
     for lInc := lY to (RegGrid.RowCount-1) do begin
         SetFOBcell(lInc
         ,gMRIFOBra[lInc+1].fobx,gMRIFOBra[lInc+1].foby,gMRIFOBra[lInc+1].fobz);
         SetMRIcell(lInc,gMRIFOBra[lInc+1].mrix,gMRIFOBra[lInc+1].mriy,gMRIFOBra[lInc+1].mriz);
     end;
  end ;
  RegGrid.RowCount := RegGrid.Rowcount -1 ;
end;

procedure TRegForm.AddBtnClick(Sender: TObject);
var lROw: integer;
begin
   lRow := RegGrid.RowCount;
   if (RegGrid.Cells[0,lRow-1] = '') and (RegGrid.Cells[1,lRow-1] = '')  then begin
      SetFOBCell(lROw-1,gXFOB,gYFOB,gZFOB);
      SetMRICell(lROw-1,gXProj,gYProj,gZProj);
   end else
   if (RegGrid.RowCount+1) < kMaxRA then begin
      RegGrid.RowCount := RegGrid.Rowcount +1;
      SetFOBCell(RegGrid.RowCount-1,gXFOB,gYFOB,gZFOB);
      SetMRICell(RegGrid.RowCount-1,gXProj,gYProj,gZProj);
   end else
        showmessage('No more data points can be entered.');
end;

procedure TRegForm.ResampleMRI1Click(Sender: TObject);
var
  lGrid: TGridRect;
  lTag: integer;
begin
        lGrid := RegGrid.Selection;
        if lGrid.Top < 1 then exit;
       lTag := ((Sender as TMEnuItem).tag);
       if lTag = 0 then begin
           RegGrid.Cells[0,lGrid.top] := inttostr(gXProj)+':'+inttostr(gYProj)+':'+inttostr(gZProj);
           gMRIFOBra[lGrid.top].mrix := gXProj;
           gMRIFOBra[lGrid.top].mriy := gYProj;
           gMRIFOBra[lGrid.top].mriz := gZProj;
       end else  begin
         SetFOBCell(lGrid.Top,gXFOB,gYFOB,gZFOB);
       end;

end;

procedure TRegForm.RegGridChangeRow(Row: integer);
begin
  if (Row < 1) or (Row >= RegGrid.RowCount) then exit;
  XEdit.value := gMRIFOBra[Row].mrix;
  YEdit.value := gMRIFOBra[Row].mriy;
  ZEdit.value := gMRIFOBra[Row].mriz;
end;

procedure TRegForm.RegGridDblClick(Sender: TObject);
var
  lGrid: TGridRect;
begin
  lGrid := RegGrid.Selection;
  if (lGrid.Left = 0) and (lGrid.top > 0) then
       RegGridChangeRow(lGrid.top);
end;

const
  kDesiredTag = 77777;//FOBs only report 0..32768, so this value indicates desired location!

procedure TRegForm.SaveBtnClick(Sender: TObject);
var
   lTextFile: textfile;
   lInc: integer;
begin
     SaveDialog1.Filter := 'Text file (*.txt)|*.txt';
     if not SaveDialog1.execute then exit;
     assignfile(lTextFile,SaveDialog1.Filename);
     rewrite(lTextFile);
     for lInc := 1 to (RegGrid.RowCount-1) do
         writeln(lTextFile,
         inttostr(gMRIFOBra[lInc].mrix)+' '+
         inttostr(gMRIFOBra[lInc].mriy)+' '+
         inttostr(gMRIFOBra[lInc].mriz)+' '+
         inttostr(gMRIFOBra[lInc].fobx)+' '+
         inttostr(gMRIFOBra[lInc].foby)+' '+
         inttostr(gMRIFOBra[lInc].fobz));
     writeln(lTextFile,
         inttostr(desirex.Value)+' '+
         inttostr(desirey.Value)+' '+
         inttostr(desirez.Value)+' '+
         inttostr(kDesiredTag)+' '+
         inttostr(kDesiredTag)+' '+
         inttostr(kDesiredTag));
     closefile(lTextFile);
end;

procedure TRegForm.OpenBtnClick(Sender: TObject);
var
   lTextFile: textfile;
   lInc,lC: integer;
begin
     if not OpenDialog1.execute then exit;
     assignfile(lTextFile,OpenDialog1.Filename);
     reset(lTextFile);
     lINc := 0;
     while not EOF(lTextFile) do begin
         inc(lInc);
         readln(lTextFile,gMRIFOBra[lInc].mrix,
         gMRIFOBra[lInc].mriy,gMRIFOBra[lInc].mriz,
         gMRIFOBra[lInc].fobx,gMRIFOBra[lInc].foby,
         gMRIFOBra[lInc].fobz);
         if  gMRIFOBra[lInc].fobx = kDesiredTag then begin //desired position
             desirex.Value := gMRIFOBra[lInc].mrix;
             desirey.Value := gMRIFOBra[lInc].mriy;
             desirez.Value := gMRIFOBra[lInc].mriz;
             dec(lInc);
         end;
     end;
    closefile(lTextFile);
     RegGrid.RowCount := lInc+1;
     for lC := 1 to lInc do begin
         SetMRIcell(lC,gMRIFOBra[lC].mrix,gMRIFOBra[lC].mriy,gMRIFOBra[lC].mriz);
         SetFOBcell(lC,gMRIFOBra[lC].fobx,gMRIFOBra[lC].foby,gMRIFOBra[lC].fobz);
     end;
     RegGrid.Selection :=TGridRect(Rect(0,1 ,1 ,1));
     RegGridDblClick(Sender);
end;

procedure TRegForm.ToolbarVis;
begin
   coolbar1.Visible := not CoolBar1.visible;
   OpenBtn.visible := not OpenBtn.visible;
   SaveBtn.visible := not SaveBtn.visible;
   AddBtn.visible := not AddBtn.visible;
   DeleteBtn.visible := not DeleteBtn.visible;
   reggrid.visible := not reggrid.visible;
end;

procedure TRegForm.RegBtnClick(Sender: TObject);
var lnObservations: integer;
    lStr: tstringlist;
begin
    lnObservations := RegGrid.RowCount-1;
    lStr := TStringList.Create;
    if PredictData(lnObservations, lStr) then
     ToolbarVis;
    Fobform.CoregMemo.Lines := lStr;
    FormulaLabel.caption :=
     'MRIx = '+floattostrf(gCoregRA[1,0],ffFixed,4,4)+' + '
     +floattostrf(gCoregRA[1,1],ffFixed,4,4)+'FOBx +'
     +floattostrf(gCoregRA[1,2],ffFixed,4,4)+'FOBy +'
     +floattostrf(gCoregRA[1,3],ffFixed,4,4)+'FOBz'+kCR+
     'MRIy = '+floattostrf(gCoregRA[2,0],ffFixed,4,4)+' + '
     +floattostrf(gCoregRA[2,1],ffFixed,4,4)+'FOBx +'
     +floattostrf(gCoregRA[2,2],ffFixed,4,4)+'FOBy +'
     +floattostrf(gCoregRA[2,3],ffFixed,4,4)+'FOBz'+kCR+
     'MRIz = '+floattostrf(gCoregRA[3,0],ffFixed,4,4)+' + '
     +floattostrf(gCoregRA[3,1],ffFixed,4,4)+'FOBx +'
     +floattostrf(gCoregRA[3,2],ffFixed,4,4)+'FOBy +'
     +floattostrf(gCoregRA[3,3],ffFixed,4,4)+'FOBz';
    lStr.Free;
end;

procedure TRegForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TRegForm.About1Click(Sender: TObject);
begin



showmessage('MRIreg2 version October 16, 2013'+kCR+'MRIreg coregisters magnetic head tracker signals with an MRI scan. '+
'For research purposes only: use with caution.'+kCR+
kCR+'Chris Rorden'+kCR+'www.mricro.com');
end;

procedure TRegForm.TableBtnClick(Sender: TObject);
begin
    ToolbarVis;
end;

procedure TRegForm.N1152001Click(Sender: TObject);
var
  lBPS: integer;
begin
  lBPS := (Sender as TMenuItem).tag;
  if (lBPS <> gBPS) then begin
    if (AdvancedMenuItem.Checked) then begin
      gBPS := lBPS;
      (sender as TMenuItem).checked := true;
      //AddBtn.Tag := gBPS;
    end else
      showmessage('Unable to change device speed (you must enable Advanced Mode)');
  end;
     InitFOBdialog;
end;

procedure TRegForm.SpeedButton1Click(Sender: TObject);
begin
     FOBForm.ShowModal;
end;

procedure TRegForm.AddMRI1Click(Sender: TObject);
begin
   AddBtn.Click;
end;

procedure TRegForm.AddRowMRIFOB1Click(Sender: TObject);
begin
  DeleteBtn.Click;
end;

procedure TRegForm.QueryOrSampleBtnClick(Sender: TObject);
begin
     if RegGrid.Visible then
      RegBtnClick(nil)
     else
      TableBtnClick(nil);
     if RegGrid.Visible then begin
      QueryOrSampleBtn.Down := false;
      RegGrid.SetFocus;
     end else
      QueryOrSampleBtn.Down := true;
end;

(*function CommPorts: byte;
var
  reg: TRegistry;
  st: Tstrings;
  i: Integer;
begin
  result := 0;
  reg := TRegistry.Create;
    Reg.Access := KEY_READ ;
  try
    reg.RootKey := HKEY_LOCAL_MACHINE;
    reg.OpenKey('HARDWARE\DEVICEMAP\SERIALCOMM', False);
    st := TstringList.Create;
    try
      reg.GetValueNames(st);
      for i := 0 to st.Count - 1 do
        GetCom(reg.Readstring(st.strings[i]));
    finally
      st.Free;
    end;
    reg.CloseKey;
  finally
    reg.Free;
  end;
end;   *)

(*function FirstAvailablePort(active: byte): byte;
//report first bit in byte, e.g. if active = 6 then returns 2
var
  i : integer;
begin
  result := 0;
  if active = 0 then
    exit;
  for i := 1 to 8 do begin
    if (active and (1 shl (i-1))) <> 0 then begin
      result := i;
      exit;
    end;

  end;
end;

function AvailablePorts(active: byte): string;
//convert active byte to high bits, e.g. if active = 5 then returns '1,3'
var
  i : integer;
begin
  if active = 0 then begin result := 'none'; exit; end;
  result := '';
  for i := 1 to 8 do begin
    if (active and (1 shl (i-1))) <> 0 then begin
      if result <> '' then
        result := result +', ';
      result := result + inttostr(i);
    end;

  end;
end;     *)

function CommPorts: Tstrings;
var
  reg: TRegistry;
  st: Tstrings;
  i: Integer;
begin
  result := TstringList.Create;
  reg := TRegistry.Create;
    Reg.Access := KEY_READ ;
  try

    reg.RootKey := HKEY_LOCAL_MACHINE;
    reg.OpenKey('HARDWARE\DEVICEMAP\SERIALCOMM', False);
    st := TstringList.Create;
    try
      reg.GetValueNames(st);
      for i := 0 to st.Count - 1 do
        result.Add (reg.Readstring(st.strings[i]));
    finally
      st.Free;
    end;
    reg.CloseKey;
  finally
    reg.Free;
  end;
end;

procedure TRegForm.StartupFOB(Sender: TObject);
var
  lPortNum: integer;
  currentports: Tstrings;
  SubItem: TMenuItem;
  i: integer;
begin
     case gBPS of
        9600: N96001.Checked := true;
        19200: N192001.Checked := true;
        38400: N384001.Checked := true;
        57600: N576001.Checked := true;
        115200: N1152001.Checked := true;
        else begin
            showmessage('Unsupported BPS: '+inttostr(gBPS)+ 'resetting to 115200 bps.');
            N1152001.Checked := true;
            gBPS := 115200;
        end;
     end; //case
     currentports := CommPorts;
     if currentports.count < 1 then
      showmessage('No serial ports detected: you will not be able to track sensors')
     else begin
        lPortNum := 0;
        for i := (currentports.count-1) downto 0 do begin
          SubItem:= TMenuItem.Create(MainMenu1);
          SubItem.Caption := currentports[i];
          SubItem.AutoCheck := true;
          if (gPort = currentports[i]) or (i = lPortNum) then begin
            lPortNum := i;
            gPort :=  currentports[i];
            SubItem.Checked := true;
          end;
          PortMenu.Add(SubItem);
        end;
        InitFOB;
     end;
    currentports.free;
    Timer1.Enabled := true;
end;

procedure TRegForm.ModeClick(Sender: TObject);
begin
  QueryOrSampleBtnClick(nil); //switch modes
end;

procedure TRegForm.Open1Click(Sender: TObject);
begin
   OpenBtn.Click;
end;

procedure TRegForm.Save1Click(Sender: TObject);
begin
    SaveBtn.Click;
end;

procedure TRegForm.updateModeMenu ;
begin
   if gIsFastrak then
    fast1.checked := true
  else if gIsStreaming then
    FlockofBirdsMiniBirdStream1.checked := true
  else
    FlockofBirdsMiniBird1.checked := true;
end;


procedure TRegForm.Fast1Click(Sender: TObject);
begin
//tag: 0/1 = flock of birds, 2 = fasttrack
  if (not AdvancedMenuItem.Checked) then begin
    showmessage('Unable to change device type (you must enable Advanced Mode)');
    exit;
  end;
 gIsFastrak := ((sender as TMenuItem).tag = 2);
 gIsStreaming := ((sender as TMenuItem).tag = 1);
 updateModeMenu;
 InitFOBdialog;
end;

procedure TRegForm.RegGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_NEXT) then
    Key := VK_DOWN;
  if  (Key = VK_PRIOR) then
    Key := VK_UP;
  if  (Key = 190) then  // '>'
    ResampleFOB1.Click;
  if (Key = 27) then
    QueryOrSampleBtn.Click;
end;

procedure TRegForm.RegGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
       RegGridChangeRow(ARow);
end;

procedure TRegForm.RegGridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
const
  SelectedColor = Clblue;
begin
  if (state = [gdSelected, gdFocused])  then
    with TStringGrid(Sender), Canvas do
    begin
      Brush.Color := SelectedColor;
      FillRect(Rect);
      TextRect(Rect, Rect.Left + 2, Rect.Top + 2, Cells[aCol, aRow]);
    end;
end;
procedure TRegForm.ResetConnectionMenuClick(Sender: TObject);
begin
     InitFOBdialog;
end;

procedure ReadReg;
var
 RegNGFS: TRegistry;
begin
  gPort := '';
  gBPS := 115200;
  gIsFastrak := false;
  gIsStreaming := true;
  RegNGFS:= TRegistry.Create;
   try
     RegNGFS.RootKey := HKEY_CURRENT_USER;
     if RegNGFS.OpenKey('SOFTWARE\MRIreg', FALSE) then begin
       gPort := RegNGFS.ReadString('PortName');
       gBPS := RegNGFS.ReadInteger('BPS');
       gIsFastrak  := RegNGFS.ReadBool('IsFastrak');
       gIsStreaming := RegNGFS.ReadBool('IsStreaming');
     end;
   finally
     RegNGFS.Free;
   end;
end;

procedure TRegForm.FormShow(Sender: TObject);
begin

 {$IFDEF useSynaSer}
 Serial1:=TBlockSerial.Create;
{$ELSE}
  Serial1 := TComPort.Create;
{$ENDIF}
  RegForm.DoubleBuffered := true;
  RegGrid.Cells[0,0] := 'MRI';
  RegGrid.Cells[1,0] := 'Flock of Birds';
  ReadReg;

   updateModeMenu;

  Timer1.Tag := 666;
  Timer1.Enabled := true;
end;

procedure  TRegForm.InitFOBdialog;
begin
  if not gIsFastrak then begin
    if Serial1.InstanceActive then 
      Serial1.SendByte(ord('B')); //point command stops any streaming
    Showmessage('Please switch on the miniBIRD/FOB tracker and set it to ''FLY''. '+
           'If the tracker was already on FLY, set it to STDBY briefly first. '+
           'Press ''OK'' when the panel light stops flashing. BPS: '+inttostr(gBPS));
  end;
  InitFOB;
end;

procedure TRegForm.InitFOB;
var
  s: string;
  i: integer;
begin
  if (gPort = '') then exit;
  RegForm.Timer1.Enabled := false;
  //Serial1.RaiseExcept:=True;
  //Serial1.Config(gBPS,8,'N',1,false,false);
  if Serial1.InstanceActive then begin
    //Serial1.SendByte(ord('B')); //point command stops any streaming
    //sleep(120); //wait for a response so it does not interfere with 79:15 call
    //Serial1.CloseSocket;
  end;
  {$IFDEF useSynaSer}
  Serial1.Connect(gPort);
  Serial1.Config(gBPS,8,'N',1,false,false);
{$ELSE}
   Serial1.Connect(gPort,gBPS);
{$ENDIF}
  //Serial1.Config(gBPS,8,'N',1,false,true);

  //Serial1.EnableRTSToggle(true);
 //  Serial1.Config(gBPS,8,'N',0,false,false);
  //Config(baud, bits: integer; parity: char; stop: integer;softflow, hardflow: boolean); virtual;

  //Serial1.Purge;
  //Serial1.Flush;

  if gIsFastrak then //Initialise FastTrack
    exit;
  //Serial1.SetBreak(100);
  while Serial1.WaitingData > 0 do
    s := char( Serial1.RecvByte(1000));
  sleep(800);
  Serial1.SendByte(79);  //EXAMINE
  Serial1.SendByte(15);//MODEL NUMBER
  //Serial1.Flush;
  sleep(800); //wait for a response
  if Serial1.WaitingData >= 10 then begin
       s := '';
       for i := 1 to 10 do
        s := s + char( Serial1.RecvByte(1000));
       Caption := s;
  end else
    Showmessage('Connection error: no response to Examine:SystemModelIdentification (79:15) "'+gPort+'" bps:'+inttostr(gBPS)+'  response(Bytes):'+inttostr(Serial1.WaitingData));
  sleep(320);//wait at least 300ms BEFORE autoconfigure
  Serial1.SendByte(241);  //address the master
  Serial1.SendByte(80);//change value
  Serial1.SendByte(50);//autoconfig
  Serial1.SendByte(1);//number of birds
  sleep (620); //After sending the AUTOCONFIGURATION wait at least 600ms
  (*Serial1.SendByte(80);//change value
  Serial1.SendByte(7);//measurement rate
  Serial1.SendByte(1);//Low Byte First
  Serial1.SendByte(86);//High byte 2nd   86.1 Hz
  sleep (50); //crx *)
  Serial1.SendByte(ord('V'));//position
  if gIsStreaming then
        Serial1.SendByte(ord('@')) //start streaming
  else
    Serial1.SendByte(ord('B')); //request first point
  //sleep (10); //crx
  gFOBActive := true;
  RegForm.Timer1.Enabled := true;
 {If you do not want a Bird data record output to your host computer every Bird
measurement cycle when in STREAM mode then use the REPORT RATE command to
change the output rate to every other cycle (R), every eight cycles (S) or every thirty-two
cycles (T). If no REPORT RATE command is issued, transmission proceeds at the
measurement rate by default.}
end;

const
     kCR = chr($0D);//carriage return (CR: 0D hex)
     kLF = chr($0A);//line-feed character (LF: 0A hex)    

function TRegForm.ReadFastrak: boolean;
var lPos,lLen,lItemsRead: integer;
    lInStr,lStr,lMostRecentFullString : string;
    lCh,lSignCh: Char;
    lDigit : boolean;
begin
   result := false;
    lItemsRead := 0;
    if Serial1.WaitingData < 6 then begin
       Serial1.SendByte(ord('P')); //request next set of data
       exit;
    end;
    if gNewLine then
       lInStr := gCurrentFastrackFragment
    else
       lInStr := '';
    lMostRecentFullString := '';
    //lNewLine := false;
    //each string STARTS with a LINEFEED and ENDS with CarriageReturn
    repeat
          lCh := chr(Serial1.RecvByte(1000));//Serial1.ReadChar(lCh);
          if (lCh = kCR) then begin
             gNewLine := false;
             lMostRecentFullString := lInStr; //will be '' unless kLF detected
             lInStr := ''; //reset string
          end;
          if gNewLine then
             lInStr := lInStr+lCh;
          if lCh = kLF then
             gNewLine := true;
    until (Serial1.WaitingData <= 0);
    if gNewLine then
       gCurrentFastrackFragment := lInStr
    else
       gCurrentFastrackFragment := '';
    Serial1.Flush;
    Serial1.SendByte(ord('P')); //request next set of data
    lLen := length(lMostRecentFullString);
    if (lLen < 9) {or (lMostRecentFullString='')} then exit; //nothing to read
    lInStr := lMostRecentFullString;
    //discard first 3 characters [header, usually 01E where E is error code]
    //so first read will be the 4th
    lPos := 4;
    lSignCh := ' ';
    repeat
          lDigit := false;
          lStr := '';
          if lSignCh <> ' ' then
             lStr := lSignCh;
          lSignCh := ' ';
          //lPrevCh := 'E';
          repeat //read characters sequentially
                lCh := lInStr[lPos];
                inc(lPos);
                //if (lCh in ['+','-','e','E','.','0'..'9']) then begin
                if (lCh in ['+','-','.','0'..'9']) then begin
                   //if lCh = 'e' then lCh := 'E';
                   if ((lCh='+') or (lCh='-')) and {(lPrevCh <> 'E')} (lDigit) then begin//only accept sign at start or after scientific notation 'E'
                      lSignCh := lCh;
                      lCh := ' '
                   end else
                       lStr := lStr + lCh;
                   if lCh in ['0'..'9'] then lDigit := true;
                end else lCh := ' ';
                //lPrevCh := lCh;
          until (lPos > lLen) or ((lDigit) and (lCh = ' '));
          inc(lItemsRead);
          Case lItemsRead of
               1: gXFOB := round(100*(strtofloat(lStr)));
               2: gYFOB := round(100*(strtofloat(lStr)));
               3: gZFOB := round(100*(strtofloat(lStr)));{}
          end;
       until {(Serial1.RxWaiting < 1)} (lPos > lLen) or (lItemsRead >= 3);
       if lItemsRead >= 3 then result := true; //success
end;

function TRegForm.ReadFOB: boolean;{only 8 msb}
const kSam = 6;//each record is 6 bytes 16 bits each for X,y,Z
var
   lRA: array [1..kSam] of byte;
   lC,lVal,lMax: integer;
begin
     result := false;

     if not gFOBactive then exit;

     if gIsFastrak then begin//Initialise FastTrack
        result := readFastrak;
        exit;
     end;
     if not gIsStreaming then Serial1.SendByte(ord('B')); //r Serial1.SendString('B'); //Point command, see page 83 of manual
     lVal := Serial1.WaitingData;
     //caption := inttostr(random(888))+' '+inttostr(Serial1.WaitingData);
 
     if (lVal < kSam)  then exit;
     lMax := (kSam+kSam-1); //every 11 bytes MUST have 6 byte sample
     if lVal > lMax then begin
        for lC := lVal downto lMax do
            Serial1.RecvByte(1000)
     end;
     repeat
        lRA[1] := Serial1.RecvByte(1000);
        if ((lRA[1] and 128) <> 0) then begin

          for lC := 2 to kSam do
            lRA[lC] := Serial1.RecvByte(1000);
        end;
     until ((lRA[1] and 128) <> 0) or (Serial1.WaitingData < kSam);

     if ((lRA[1] and 128) = 0) then exit;
     //caption := inttostr(lRA[1])+' '+inttostr(lRA[2])+' '+inttostr(lRA[3])+' '+inttostr(lRA[4])+' '+inttostr(lRA[5])+' '+inttostr(lRA[6])+' '+inttostr(random(888));
     result := true;
     gXFOB := smallint((lRA[2] shl 9) + ((lRA[1] and 127) shl 2 ));
     gYFOB := smallint((lRA[4] shl 9) + ((lRA[3] )shl 2 ));
     gZFOB := smallint((lRA[6] shl 9) + ((lRA[5] )shl 2 ));
end; {readFOB}

end.
